/*
 * Decompiled with CFR 0.152.
 * 
 * Could not load the following classes:
 *  fire.pb.battle.BattleField
 *  fire.pb.battle.Fighter
 *  fire.pb.buff.BuffPetImpl
 *  fire.pb.buff.Module
 *  fire.pb.buff.continual.ConstantlyBuff
 *  fire.pb.main.ConfigManager
 *  fire.pb.pet.Pet
 *  fire.pb.skill.fight.FightSkillConfig
 *  fire.pb.skill.liveskill.LiveSkillManager
 *  fire.script.AbstractJSEngine
 *  fire.script.FightJSEngine
 *  fire.script.JavaScript
 *  xbean.BattleInfo
 *  xbean.PetInfo
 *  xbean.PracticeSkill
 */
package fire.pb.skill;

import fire.pb.battle.BattleField;
import fire.pb.battle.Fighter;
import fire.pb.buff.BuffPetImpl;
import fire.pb.buff.continual.ConstantlyBuff;
import fire.pb.main.ConfigManager;
import fire.pb.pet.Pet;
import fire.pb.skill.BuffUnit;
import fire.pb.skill.Module;
import fire.pb.skill.Result;
import fire.pb.skill.SSkillConfig;
import fire.pb.skill.SkillAgent;
import fire.pb.skill.SkillConstant;
import fire.pb.skill.SkillRole;
import fire.pb.skill.SubSkillConfig;
import fire.pb.skill.fight.FightSkillConfig;
import fire.pb.skill.liveskill.LiveSkillManager;
import fire.script.AbstractJSEngine;
import fire.script.FightJSEngine;
import fire.script.JavaScript;
import java.util.ArrayList;
import java.util.List;
import java.util.Map;
import xbean.BattleInfo;
import xbean.PetInfo;
import xbean.PracticeSkill;

public class SkillPet
extends SkillAgent {
    private long roleid;
    private Pet pet;

    public SkillPet(PetInfo petinfo, long roleid) {
        this.pet = Pet.getPet((PetInfo)petinfo);
        this.agentType = 2;
        this.roleid = roleid;
    }

    @Override
    public boolean hasEffectSkill(int skillId) {
        SSkillConfig cfg = (SSkillConfig)ConfigManager.getInstance().getConf(SSkillConfig.class).get(skillId);
        if (cfg == null) {
            return false;
        }
        if (cfg.isActive) {
            return this.getLevel(skillId) > 0;
        }
        return this.getLevel(skillId) > 0;
    }

    @Override
    public boolean hasSkill(int skillId) {
        return this.getLevel(skillId) > 0;
    }

    @Override
    public boolean hasAllSkills(int ... skillIds) {
        int[] nArray = skillIds;
        int n = skillIds.length;
        int n2 = 0;
        while (n2 < n) {
            int skillId = nArray[n2];
            if (!this.pet.hasSkill(skillId) && !this.pet.hasInternal(skillId)) {
                return false;
            }
            ++n2;
        }
        return true;
    }

    @Override
    public boolean hasAnySkill(int ... skillIds) {
        int[] nArray = skillIds;
        int n = skillIds.length;
        int n2 = 0;
        while (n2 < n) {
            int skillId = nArray[n2];
            if (this.pet.hasAnySkill(skillId)) {
                return true;
            }
            if (this.pet.hasAnyInternal(skillId)) {
                return true;
            }
            ++n2;
        }
        return false;
    }

    @Override
    public int getLevel(int skillId) {
        SkillRole srole = new SkillRole(this.roleid, true);
        if (skillId >= 100000 && skillId < 110000) {
            SkillConstant.BasicSkillBelongs user = SkillConstant.basicSkillUsers.get(skillId);
            if (user == null) {
                return 0;
            }
            if (user.isBelongToPet()) {
                return 1;
            }
            return 0;
        }
        if (skillId > 200000 && skillId < 210000) {
            return this.pet.getSkillLevel(skillId);
        }
        if (skillId > 230000 && skillId < 250000) {
            return this.pet.getInternalLevel(skillId);
        }
        int skillType = skillId / 100000;
        if (skillType == 9) {
            int id = LiveSkillManager.getInstance().GetPracticePassivenessSkillLevelBattleSkill(skillId);
            PracticeSkill skill = srole.getPracticeSkill(id);
            if (skill != null) {
                return skill.getLevel();
            }
            return 0;
        }
        if (this.pet.hasSkill(skillId)) {
            return 1;
        }
        if (this.pet.hasInternal(skillId)) {
            return 1;
        }
        return 0;
    }

    @Override
    public List<Integer> getAllBattleSkills() {
        ArrayList<Integer> skillIds = new ArrayList<Integer>();
        SkillRole srole = new SkillRole(this.roleid, true);
        skillIds.addAll(LiveSkillManager.getInstance().GetAllPracticeSkillBattleSkill(srole, 1));
        skillIds.addAll(this.pet.getBattleskillIds());
        skillIds.addAll(this.pet.getBattleInternalIds());
        return skillIds;
    }

    public Result updateSkillBuffWhileOut(BattleInfo battle) {
        Result result = new Result(true);
        FightJSEngine fightJSEngine = null;
        boolean binitJsEngine = false;
        BuffPetImpl buffpet = new BuffPetImpl(this.pet.getPetInfo());
        for (int skillId : this.getAllBattleSkills()) {
            FightSkillConfig sconf = Module.getInstance().getFightSkillConfig(skillId);
            if (sconf == null) {
                Module.logger.error((Object)("宠物的FightSkillConfig为空，技能ID = " + skillId), (Throwable)new NullPointerException());
                continue;
            }
            if (sconf.isActiveSkill() || sconf.getType() != 10 || sconf.getSubSkills()[0] == null || sconf.getSubSkills()[0].getBuffUnits()[0] == null) continue;
            SubSkillConfig[] subSkillConfigArray = sconf.getSubSkills();
            int n = subSkillConfigArray.length;
            int n2 = 0;
            while (n2 < n) {
                SubSkillConfig subskill = subSkillConfigArray[n2];
                BuffUnit[] buffUnitArray = subskill.getBuffUnits();
                int n3 = buffUnitArray.length;
                int n4 = 0;
                while (n4 < n3) {
                    BuffUnit buffarg = buffUnitArray[n4];
                    if (buffarg != null && buffarg.buffIndex / 10000 != 51) {
                        ConstantlyBuff buff = fire.pb.buff.Module.getInstance().createConstantlyBuff(buffarg.buffIndex);
                        if (buff == null) {
                            BattleField.logger.error((Object)("updateSkillBuffWhileOut 技能ID = " + skillId + "中有buff无法生成实例，buffid = " + buffarg.buffIndex));
                        } else {
                            int nround;
                            if (!binitJsEngine) {
                                fightJSEngine = battle == null ? new FightJSEngine() : battle.getEngine();
                                if (fightJSEngine != null) {
                                    fightJSEngine.setGrade((int)this.pet.getLevel());
                                }
                                binitJsEngine = true;
                            }
                            if (fightJSEngine != null) {
                                fightJSEngine.setSkillLevel(this.getLevel(skillId));
                            }
                            if ((nround = buffarg.roundJavascript.eval((AbstractJSEngine)fightJSEngine, null, null).intValue()) != 0) {
                                buff.setRound(nround);
                            }
                            if (buffarg.effectJavascriptMap.size() > 0) {
                                for (Map.Entry<Integer, JavaScript> entry : buffarg.effectJavascriptMap.entrySet()) {
                                    buff.getEffects().put(entry.getKey(), Float.valueOf(entry.getValue().eval((AbstractJSEngine)fightJSEngine, null, null).floatValue()));
                                }
                            }
                            result.updateResult(buffpet.addCBuff(buff));
                        }
                    }
                    ++n4;
                }
                ++n2;
            }
        }
        return result;
    }

    @Override
    public Result addSkillBuffWhileOnline(BattleInfo battle) {
        return this.updateSkillBuffWhileOut(battle);
    }

    @Override
    public Result addSkillBuffWhileBattle(BattleInfo battle, Fighter ofighter) {
        BuffPetImpl buffpet = new BuffPetImpl(this.pet.getPetInfo());
        Result result = new Result(true);
        for (int skillId : this.getAllBattleSkills()) {
            FightSkillConfig sconf = Module.getInstance().getFightSkillConfig(skillId);
            if (sconf == null) {
                if (!BattleField.logger.isDebugEnabled()) continue;
                BattleField.logger.debug((Object)("FightSkillConfig为空，技能ID = " + skillId), (Throwable)new NullPointerException());
                continue;
            }
            boolean bl = false;
        }
        return result;
    }
}

